import com.sun.jna.platform.win32.Kernel32;
import com.sun.jna.platform.win32.Kernel32Util;
import com.sun.jna.ptr.LongByReference;

public class DeviceList {
    static private Kernel32 kernel32;

    public DeviceList() {
        try {
            kernel32 = Kernel32.INSTANCE;
        } catch (NoClassDefFoundError e) {
        } catch (UnsatisfiedLinkError e) {
            // do nothing
        }
    }
    
    public String getAllDevices(int dev) {
        if (kernel32 == null) return "";
        int target = 0;
        if (dev == AlertUSB.DEV_USB) target = Kernel32.DRIVE_REMOVABLE;
        if (dev == AlertUSB.DEV_DVD) target = Kernel32.DRIVE_CDROM;
        String ret = "";

        String drives[] = Kernel32Util.getLogicalDriveStrings();
        for (String path : drives) {
            if (kernel32.GetDriveType(path)==target && mediaExists(path)) {
                ret += path;
            }
        }   
        return ret;
    }

    private boolean mediaExists(String path) {
        // Three LongByReference(s) are dummy.
        LongByReference freeBytesAvailable = new LongByReference();
        LongByReference totalNumberOfBytes = new LongByReference();
        LongByReference totalNumberOfFreeBytes = new LongByReference();
        boolean ret = kernel32.GetDiskFreeSpaceEx(path, freeBytesAvailable,
                totalNumberOfBytes, totalNumberOfFreeBytes);
        //System.out.println(driveLetter + " : " + totalNumberOfFreeBytes.getValue() + ret);
        return ret;
    }
    
	// TODO:取り外し処理
    public void eject(String path) {
    }
}
